


/* config.h -- configuration handler.

 * Copyright (C) 1999 Yarick Rastrigin <yarick@relex.ru>
 *                    Steve Hill <sjhill@plutonium.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _CONFIG_H_
#define _CONFIG_H_

typedef char *(*GetValueFunc) (void);
typedef void (*SetValueFunc) (char *);

extern void load_config (gchar *);
extern void save_config (gchar *);

extern void load_typedata (gchar *);
extern void save_typedata (gchar *);

extern void *find_typedef (gchar *);
extern void *find_typedef_by_substr(gchar *substr);
extern gchar *find_action (void *, gchar *);
typedef struct
  {
    gchar *name, *default_value;
    GetValueFunc get_func;
    SetValueFunc set_func;
  }
config_item;

/*
   Short description of items:
   name: that one which appears in config file;
   default_value: when no config file info available;
   get_func: pointer to function which retrieves this param and converts value to char *
   set_func: pointer to function which gets this param in char * form and sets this parameter
 */


#endif /* __CONFIG_H_ */
